/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.database.Cursor;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.gtask.exception.ActionFailureException;
import net.micode.notes.tool.GTaskStringUtils;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;

public class TaskList extends Node {
    private static final String TAG = TaskList.class.getSimpleName();

    private int mIndex; // 任务列表的索引
    private ArrayList<Task> mChildren; // 子任务列表

    // 构造函数
    public TaskList() {
        super(); // 调用父类的构造函数
        mChildren = new ArrayList<Task>(); // 初始化子任务列表
        mIndex = 1; // 设置任务列表的索引为1
    }

    // 获取创建操作的JSON对象
    public JSONObject getCreateAction(int actionId) {
        JSONObject js = new JSONObject();

        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE, GTaskStringUtils.GTASK_JSON_ACTION_TYPE_CREATE); // 设置操作类型为创建

            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId); // 设置操作ID

            // index
            js.put(GTaskStringUtils.GTASK_JSON_INDEX, mIndex); // 设置索引

            // entity_delta
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName()); // 设置任务列表的名称
            entity.put(GTaskStringUtils.GTASK_JSON_CREATOR_ID, "null"); // 创建者ID设置为"null"
            entity.put(GTaskStringUtils.GTASK_JSON_ENTITY_TYPE, GTaskStringUtils.GTASK_JSON_TYPE_GROUP); // 设置实体类型为组类型
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity); // 将实体信息加入到JSON对象中

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("fail to generate tasklist-create jsonobject"); // 抛出操作失败异常
        }

        return js; // 返回JSON对象
    }
}
    public JSONObject getUpdateAction(int actionId) {
        JSONObject js = new JSONObject();

        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE, GTaskStringUtils.GTASK_JSON_ACTION_TYPE_UPDATE); // 设置操作类型为更新

            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId); // 设置操作ID

            // id
            js.put(GTaskStringUtils.GTASK_JSON_ID, getGid()); // 设置任务列表的唯一标识符

            // entity_delta
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName()); // 设置任务列表的名称
            entity.put(GTaskStringUtils.GTASK_JSON_DELETED, getDeleted()); // 设置任务列表的删除状态
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity); // 将实体信息加入到JSON对象中

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("fail to generate tasklist-update jsonobject"); // 抛出操作失败异常
        }

        return js; // 返回JSON对象
    }
    public void setContentByRemoteJSON(JSONObject js) {
        if (js != null) {
            try {
                // id
                if (js.has(GTaskStringUtils.GTASK_JSON_ID)) {
                    setGid(js.getString(GTaskStringUtils.GTASK_JSON_ID)); // 从远程的JSON对象中获取任务列表的唯一标识符，并设置给当前对象的gid属性
                }

                // last_modified
                if (js.has(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED)) {
                    setLastModified(js.getLong(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED)); // 从远程的JSON对象中获取任务列表的最后修改时间，并设置给当前对象的lastModified属性
                }

                // name
                if (js.has(GTaskStringUtils.GTASK_JSON_NAME)) {
                    setName(js.getString(GTaskStringUtils.GTASK_JSON_NAME)); // 从远程的JSON对象中获取任务列表的名称，并设置给当前对象的name属性
                }

            } catch (JSONException e) {
                Log.e(TAG, e.toString());
                e.printStackTrace();
                throw new ActionFailureException("fail to get tasklist content from jsonobject"); // 抛出操作失败异常
            }
        }
    }
    public void setContentByLocalJSON(JSONObject js) {
        if (js == null || !js.has(GTaskStringUtils.META_HEAD_NOTE)) {
            Log.w(TAG, "setContentByLocalJSON: nothing is avaiable");
        }

        try {
            JSONObject folder = js.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);

            if (folder.getInt(NoteColumns.TYPE) == Notes.TYPE_FOLDER) {
                String name = folder.getString(NoteColumns.SNIPPET);
                setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX + name); // 从本地的JSON对象中获取文件夹类型的任务列表的名称，并在前面添加一定的前缀后，设置给当前对象的name属性
            } else if (folder.getInt(NoteColumns.TYPE) == Notes.TYPE_SYSTEM) {
                if (folder.getLong(NoteColumns.ID) == Notes.ID_ROOT_FOLDER)
                    setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX + GTaskStringUtils.FOLDER_DEFAULT); // 如果是系统文件夹类型的任务列表，则根据其ID设置对应的名称
                else if (folder.getLong(NoteColumns.ID) == Notes.ID_CALL_RECORD_FOLDER)
                    setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX + GTaskStringUtils.FOLDER_CALL_NOTE);
                else
                    Log.e(TAG, "invalid system folder");
            } else {
                Log.e(TAG, "error type");
            }
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }
    }
    public JSONObject getLocalJSONFromContent() {
        try {
            JSONObject js = new JSONObject();
            JSONObject folder = new JSONObject();

            String folderName = getName();
            if (getName().startsWith(GTaskStringUtils.MIUI_FOLDER_PREFFIX))
                folderName = folderName.substring(GTaskStringUtils.MIUI_FOLDER_PREFFIX.length(),
                        folderName.length());
            folder.put(NoteColumns.SNIPPET, folderName); // 将任务列表对象的名称设置为文件夹的摘要，并添加到folder对象中
            if (folderName.equals(GTaskStringUtils.FOLDER_DEFAULT)
                    || folderName.equals(GTaskStringUtils.FOLDER_CALL_NOTE))
                folder.put(NoteColumns.TYPE, Notes.TYPE_SYSTEM); // 如果文件夹名称是默认或通话记录类型，则将文件夹类型设置为系统类型
            else
                folder.put(NoteColumns.TYPE, Notes.TYPE_FOLDER); // 否则，将文件夹类型设置为普通文件夹类型

            js.put(GTaskStringUtils.META_HEAD_NOTE, folder); // 将folder对象添加到最终的JSON对象js中

            return js; // 返回构建好的JSON对象
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            return null;
        }
    }

    public int getSyncAction(Cursor c) {
        try {
            if (c.getInt(SqlNote.LOCAL_MODIFIED_COLUMN) == 0) {
                // 如果本地修改标志位为0，表示没有本地更新
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // 如果同步ID与最后修改时间相等，表示双方都没有更新
                    return SYNC_ACTION_NONE; // 返回不需要进行同步操作
                } else {
                    // 如果同步ID与最后修改时间不相等，表示远程有更新，需要将远程更新应用到本地
                    return SYNC_ACTION_UPDATE_LOCAL; // 返回更新本地的同步操作
                }
            } else {
                // 如果本地修改标志位为1，表示有本地更新
                // 验证gtask id是否匹配
                if (!c.getString(SqlNote.GTASK_ID_COLUMN).equals(getGid())) {
                    Log.e(TAG, "gtask id doesn't match");
                    return SYNC_ACTION_ERROR; // 返回同步操作错误
                }
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // 如果同步ID与最后修改时间相等，表示只有本地修改
                    return SYNC_ACTION_UPDATE_REMOTE; // 返回更新远程的同步操作
                } else {
                    // 对于文件夹冲突，仅应用本地修改
                    return SYNC_ACTION_UPDATE_REMOTE; // 返回更新远程的同步操作
                }
            }
        } catch (Exception e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }

        return SYNC_ACTION_ERROR; // 返回同步操作错误
    }
import java.util.ArrayList;
        import android.util.Log;

public class Task {
    private static final String TAG = "Task";
    private ArrayList<Task> mChildren; // 子任务列表
    private int mIndex; // 索引

    // 获取子任务数量
    public int getChildTaskCount() {
        return mChildren.size();
    }

    // 添加子任务
    public boolean addChildTask(Task task) {
        boolean ret = false;
        if (task != null && !mChildren.contains(task)) {
            ret = mChildren.add(task);
            if (ret) {
                // 设置前一个兄弟节点和父节点
                task.setPriorSibling(mChildren.isEmpty() ? null : mChildren.get(mChildren.size() - 1));
                task.setParent(this);
            }
        }
        return ret;
    }

    // 在指定位置添加子任务
    public boolean addChildTask(Task task, int index) {
        if (index < 0 || index > mChildren.size()) {
            Log.e(TAG, "add child task: invalid index");
            return false;
        }

        int pos = mChildren.indexOf(task);
        if (task != null && pos == -1) {
            mChildren.add(index, task);

            // 更新任务列表
            Task preTask = null;
            Task afterTask = null;
            if (index != 0)
                preTask = mChildren.get(index - 1);
            if (index != mChildren.size() - 1)
                afterTask = mChildren.get(index + 1);

            task.setPriorSibling(preTask);
            if (afterTask != null)
                afterTask.setPriorSibling(task);
        }

        return true;
    }

    // 移除子任务
    public boolean removeChildTask(Task task) {
        boolean ret = false;
        int index = mChildren.indexOf(task);
        if (index != -1) {
            ret = mChildren.remove(task);

            if (ret) {
                // 重置前一个兄弟节点和父节点
                task.setPriorSibling(null);
                task.setParent(null);

                // 更新任务列表
                if (index != mChildren.size()) {
                    mChildren.get(index).setPriorSibling(
                            index == 0 ? null : mChildren.get(index - 1));
                }
            }
        }
        return ret;
    }

    // 移动子任务到指定位置
    public boolean moveChildTask(Task task, int index) {
        if (index < 0 || index >= mChildren.size()) {
            Log.e(TAG, "move child task: invalid index");
            return false;
        }

        int pos = mChildren.indexOf(task);
        if (pos == -1) {
            Log.e(TAG, "move child task: the task should in the list");
            return false;
        }

        if (pos == index)
            return true;
        return (removeChildTask(task) && addChildTask(task, index));
    }

    // 根据任务ID查找子任务
    public Task findChildTaskByGid(String gid) {
        for (int i = 0; i < mChildren.size(); i++) {
            Task t = mChildren.get(i);
            if (t.getGid().equals(gid)) {
                return t;
            }
        }
        return null;
    }

    // 获取子任务在列表中的索引
    public int getChildTaskIndex(Task task) {
        return mChildren.indexOf(task);
    }

    // 根据索引获取子任务
    public Task getChildTaskByIndex(int index) {
        if (index < 0 || index >= mChildren.size()) {
            Log.e(TAG, "getTaskByIndex: invalid index");
            return null;
        }
        return mChildren.get(index);
    }

    // 根据任务ID获取子任务
    public Task getChilTaskByGid(String gid) {
        for (Task task : mChildren) {
            if (task.getGid().equals(gid))
                return task;
        }
        return null;
    }

    // 获取子任务列表
    public ArrayList<Task> getChildTaskList() {
        return this.mChildren;
    }

    // 设置索引
    public void setIndex(int index) {
        this.mIndex = index;
    }

    // 获取索引
    public int getIndex() {
        return this.mIndex;
    }

    // 其他属性和方法的定义
}
